Index: LMDZ.3.3/branches/rel-LF/libf/dyn3d/abort_gcm.F
===================================================================
--- LMDZ.3.3/branches/rel-LF/libf/dyn3d/abort_gcm.F	(revision 201)
+++ LMDZ.3.3/branches/rel-LF/libf/dyn3d/abort_gcm.F	(revision 205)
@@ -1,2 +1,5 @@
+c
+c $Header
+c
       SUBROUTINE abort_gcm(modname, message, ierr)
      
@@ -16,4 +19,5 @@
       write(*,*) 'in abort_gcm'
       call histclo
+      call restclo
 c     call histclo(2)
 c     call histclo(3)
Index: LMDZ.3.3/branches/rel-LF/libf/phylmd/clmain.F
===================================================================
--- LMDZ.3.3/branches/rel-LF/libf/phylmd/clmain.F	(revision 201)
+++ LMDZ.3.3/branches/rel-LF/libf/phylmd/clmain.F	(revision 205)
@@ -1,3 +1,3 @@
-      SUBROUTINE clmain(dtime,itap,pctsrf,
+      SUBROUTINE clmain(dtime,itap,date0,pctsrf,
      .                  t,q,u,v,
      .                  jour, rmu0,
@@ -36,4 +36,5 @@
 c dtime----input-R- interval du temps (secondes)
 c itap-----input-I- numero du pas de temps
+c date0----input-R- jour initial
 c t--------input-R- temperature (K)
 c q--------input-R- vapeur d'eau (kg/kg)
@@ -76,4 +77,5 @@
 c
       REAL dtime
+      real date0
       integer itap
       REAL t(klon,klev), q(klon,klev)
@@ -368,5 +370,5 @@
 
 c calculer la diffusion de "q" et de "h"
-      CALL clqh(dtime, itap, jour, debut,lafin,
+      CALL clqh(dtime, itap, date0,jour, debut,lafin,
      e          rlon, rlat, cufi, cvfi,
      e          knon, nsrf, ni, pctsrf,
@@ -479,5 +481,5 @@
       RETURN
       END
-      SUBROUTINE clqh(dtime,itime, jour,debut,lafin,
+      SUBROUTINE clqh(dtime,itime, date0,jour,debut,lafin,
      e                rlon, rlat, cufi, cvfi, 
      e                knon, nisurf, knindex, pctsrf,
@@ -512,4 +514,5 @@
       INTEGER knon
       REAL dtime              ! intervalle du temps (s)
+      real date0
       REAL u1lay(klon)        ! vitesse u de la 1ere couche (m/s)
       REAL v1lay(klon)        ! vitesse v de la 1ere couche (m/s)
@@ -729,5 +732,5 @@
       ccanopy = 365.
 
-      CALL interfsurf(itime, dtime, jour, rmu0,
+      CALL interfsurf(itime, dtime, date0, jour, rmu0,
      e klon, iim, jjm, nisurf, knon, knindex, pctsrf, 
      e rlon, rlat, cufi, cvfi, 
Index: LMDZ.3.3/branches/rel-LF/libf/phylmd/interface_surf.F90
===================================================================
--- LMDZ.3.3/branches/rel-LF/libf/phylmd/interface_surf.F90	(revision 201)
+++ LMDZ.3.3/branches/rel-LF/libf/phylmd/interface_surf.F90	(revision 205)
@@ -49,5 +49,5 @@
 !############################################################################
 !
-  SUBROUTINE interfsurf_hq(itime, dtime, jour, rmu0, &
+  SUBROUTINE interfsurf_hq(itime, dtime, date0, jour, rmu0, &
       & klon, iim, jjm, nisurf, knon, knindex, pctsrf, &
       & rlon, rlat, cufi, cvfi,&
@@ -77,4 +77,5 @@
 !   iim, jjm     nbres de pts de grille
 !   dtime        pas de temps de la physique (en s)
+!   date0        jour initial 
 !   jour         jour dans l'annee en cours,
 !   rmu0         cosinus de l'angle solaire zenithal
@@ -138,4 +139,5 @@
   integer, intent(IN) :: klon
   real, intent(IN) :: dtime
+  real, intent(IN) :: date0
   integer, intent(IN) :: jour
   real, intent(IN)    :: rmu0(klon)
@@ -345,5 +347,5 @@
       scatter= .true.
       if (.not. scatter) then
-        call interfsol(itime, klon, dtime, nisurf, knon, &
+        call interfsol(itime, klon, dtime, date0, nisurf, knon, &
      &  knindex, rlon, rlat, cufi, cvfi, iim, jjm, pctsrf, &
      &  debut, lafin, ok_veget, &
@@ -355,5 +357,5 @@
      &  tsol_rad, tsurf_new, alb_new, emis_new, z0_new, dflux_l, dflux_s)
       else
-        call interfsol_scat(itime, klon, dtime, nisurf, knon, &
+        call interfsol_scat(itime, klon, dtime, date0, nisurf, knon, &
      &  knindex, rlon, rlat, cufi, cvfi, iim, jjm, pctsrf, &
      &  debut, lafin, ok_veget, &
@@ -622,5 +624,5 @@
 !#########################################################################
 !
-  SUBROUTINE interfsol(itime, klon, dtime, nisurf, knon, &
+  SUBROUTINE interfsol(itime, klon, dtime, date0, nisurf, knon, &
      & knindex, rlon, rlat, cufi, cvfi, iim, jjm, pctsrf, &
      & debut, lafin, ok_veget, &
@@ -694,4 +696,5 @@
   integer, intent(IN) :: klon
   real, intent(IN)    :: dtime
+  real, intent(IN)    :: date0
   integer, intent(IN) :: nisurf
   integer, intent(IN) :: knon
@@ -754,5 +757,4 @@
   real, dimension(klon):: qsurf
   real, dimension(klon):: snow, qsol
-  real, save                 :: date0 = 0.
   real, dimension(knon,2) :: albedo_out
 ! Pb de nomenclature
@@ -963,5 +965,5 @@
 !#########################################################################
 !
-  SUBROUTINE interfsol_scat(itime, klon, dtime, nisurf, knon, &
+  SUBROUTINE interfsol_scat(itime, klon, dtime, date0, nisurf, knon, &
      & knindex, rlon, rlat, cufi, cvfi, iim, jjm, pctsrf, &
      & debut, lafin, ok_veget, &
@@ -1035,4 +1037,5 @@
   integer, intent(IN) :: klon
   real, intent(IN)    :: dtime
+  real, intent(IN)    :: date0
   integer, intent(IN) :: nisurf
   integer, intent(IN) :: knon
@@ -1095,5 +1098,4 @@
   real, dimension(klon):: qsurf
   real, dimension(klon):: snow, qsol
-  real, save                 :: date0 = 0.
   real, dimension(knon,2) :: albedo_out
 ! Pb de nomenclature
@@ -1192,4 +1194,5 @@
 !
   if (debut) then
+    if (check) write(*,*) 'debut orchidee itime - 1', itime-1,date0
     call intersurf_main (itime-1, iim, jjm+1 , knon, knindex, dtime, &
      & lrestart_read, lrestart_write, lon_sc, lat_sc, &
Index: LMDZ.3.3/branches/rel-LF/libf/phylmd/physiq.F
===================================================================
--- LMDZ.3.3/branches/rel-LF/libf/phylmd/physiq.F	(revision 201)
+++ LMDZ.3.3/branches/rel-LF/libf/phylmd/physiq.F	(revision 205)
@@ -94,6 +94,6 @@
 ccc      PARAMETER (soil_model=.FALSE.)
       logical ok_veget
-      parameter (ok_veget = .false.)
-c      parameter (ok_veget = .true.)
+      parameter (ok_veget = .true.)
+c      parameter (ok_veget = .false.)
 c======================================================================
 c Dans les versions precedentes, l'eau liquide nuageuse utilisee dans
@@ -118,5 +118,5 @@
 c
       LOGICAL ok_instan ! sortir le fichier instantane
-      PARAMETER (ok_instan=.true.)
+      PARAMETER (ok_instan=.false.)
 c
       LOGICAL ok_region ! sortir le fichier regional
@@ -499,5 +499,5 @@
       character*80 abort_message
       logical ok_sync
-
+      real date0
 
 c
@@ -1525,5 +1525,4 @@
 c Verifier les temperatures
 c
-
       CALL hgardfou(t_seri,ftsol,'debutphy')
 c
@@ -1593,6 +1592,7 @@
 
       fder = 0.
-
-      CALL clmain(dtime,itap,pctsrf,
+      date0 = day_ini
+
+      CALL clmain(dtime,itap,date0,pctsrf,
      e            t_seri,q_seri,u_seri,v_seri,
      e            julien, rmu0, 
@@ -1607,4 +1607,5 @@
      s            dsens, devap,
      s            ycoefh,yu1,yv1) 
+
 c
 C§§§ PB
@@ -1633,4 +1634,7 @@
 c         evap(i) = - fluxq(i,1) ! flux d'evaporation au sol
          evap(i) = - zxfluxq(i,1) ! flux d'evaporation au sol
+C LF test signe flux
+         sens(i) = zxfluxt(i,1)
+         evap(i) = zxfluxq(i,1)
          fder(i) = dsens(i) + devap(i)
       ENDDO
@@ -1738,13 +1742,14 @@
       CALL abort
       ENDIF
+
       CALL homogene(paprs, q_seri, d_q_con, u_seri,v_seri,
      .              d_u_con, d_v_con)
       DO k = 1, klev
-      DO i = 1, klon
+        DO i = 1, klon
          t_seri(i,k) = t_seri(i,k) + d_t_con(i,k)
          q_seri(i,k) = q_seri(i,k) + d_q_con(i,k)
          u_seri(i,k) = u_seri(i,k) + d_u_con(i,k)
          v_seri(i,k) = v_seri(i,k) + d_v_con(i,k)
-      ENDDO
+        ENDDO
       ENDDO
       IF (check) THEN
Index: LMDZ.3.3/branches/rel-LF/makegcm
===================================================================
--- LMDZ.3.3/branches/rel-LF/makegcm	(revision 201)
+++ LMDZ.3.3/branches/rel-LF/makegcm	(revision 205)
@@ -77,11 +77,14 @@
 #Force/couple
 set COUPLE=0
-set ocean=`grep '^      parameter (ocean' libf/phylmd/physiq.F | awk -F\' '{print $2}'`
+set ocean=`grep '^      parameter (ocean' $LMDGCM/libf/phylmd/physiq.F | awk -F\' '{print $2}'`
 banner $ocean
 if ($ocean == couple) then
   set COUPLE=1
 endif
-
-
+#veget ou non
+set veget=`grep '^      parameter (ok_veget' $LMDGCM/libf/phylmd/physiq.F | awk -F. '{print $2}'`
+if ($veget == true) then
+  banner orchidee
+endif
 ########################################################################
 #  Les differentes platformes reconnues