Index: DZ.3.3/trunk/libf/dyn3d/run.def
===================================================================
--- /LMDZ.3.3/trunk/libf/dyn3d/run.def	(revision 210)
+++ 	(revision )
@@ -1,187 +1,0 @@
-
------------------------------------------------------------------------ 
-Parametres de controle du run:                                          
-------------------------------                                          
-
-- Jour de l'etat initial ( = 350  si 20 Decembre ,par expl. ,comme ici ) 
-   dayref
- 350
-
--  Annee de l'etat  initial (   avec  4  chiffres   )                        
-   anneeref
- 1987
-
-- Nombre de jours d'integration                                         
-     nday
- 2
-
-- nombre de pas par jour (multiple de iperiod) ( ici pour  dt = 1 min )      
- day_step
- 1440
-
-- periode pour le pas Matsuno (en pas)                                  
-  iperiod
- 5
-
-- periode de sortie des variables de controle (en pas)                  
-  iconser
- 5
-
-- periode d'ecriture du fichier histoire (en jour)                      
-    iecri
- 100
-
-- periode de stockage fichier histmoy (en jour)                         
- periodav
- 60.
-
-- periode de la dissipation (en pas)                                    
-  idissip
- 10
-
-- choix de l'operateur de dissipation (star ou  non star )              
- lstardis
- T
-
-- nombre d'iterations de l'operateur de dissipation   gradiv            
-nitergdiv
- 1
-
-- nombre d'iterations de l'operateur de dissipation  nxgradrot          
-nitergrot
- 2
-
-- nombre d'iterations de l'operateur de dissipation  divgrad            
-   niterh
- 2
-
-- temps de dissipation des plus petites long.d ondes pour u,v (gradiv)  
- tetagdiv
- 3000.
-
-- temps de dissipation des plus petites long.d ondes pour u,v(nxgradrot)
- tetagrot
- 3000.
-
-- temps de dissipation des plus petites long.d ondes pour  h ( divgrad) 
- tetatemp
- 3000.
-
-- coefficient pour gamdissip                                            
-  coefdis
- 0.
-
-- choix du shema d'integration temporelle (Matsuno ou Matsuno-leapfrog) 
-  purmats
- F
-
-- avec ou sans physique                                                 
-   physic
- T
-
-- periode de la physique (en pas)                                       
-  iphysiq
- 15
-
-- frequence (en  jours ) de l'ecriture du fichier histphy               
- ecritphy
- 4
-
--  Cycle diurne  ou non                 
- cycle_diurne
- T
-
--  Soil Model  ou non               
- soil_model
- F
-
--  Choix ou non  de  New oliq               
- new_oliq
- T
-
--  Orodr  ou  non   pour l orographie              
-  ok_orodr
- T
-
--  Orolf  ou  non   pour l orographie              
-  ok_orolf
- T
-
--   Si = .T. ,  lecture du fichier limit avec la bonne annee             
-  ok_limitvrai
- T
-
-- Nombre  d'appels des routines de rayonnements ( par jour)                 
-  nbapp_rad
- 12
-
--  Flag  pour la convection ( 1 pour LMD,  2 pour Tiedtke, 3  CCM )             
-  iflag_con
- 2
-
-- longitude en degres du centre du zoom                                 
-   clon
- 63.
-
-- latitude en degres du centre du zoom                                  
-   clat
- 0.
-
-- facteur de grossissement du zoom,selon longitude                      
-  grossismx
- 2.5
-
-- facteur de grossissement du zoom ,selon latitude                      
- grossismy
- 2.5
-
--  Fonction  f(y)  hyperbolique  si = .true.  , sinon  sinusoidale         
-  fxyhypb
- T
-
-- extension en longitude  de la zone du zoom  ( fraction de la zone totale)
-   dzoomx
- 0.291667
-
-- extension en latitude de la zone  du zoom  ( fraction de la zone totale)
-   dzoomy
- 0.291667
-
--  Fonction  f(y) avec y = Sin(latit.) si = .true. , sinon y = latit.         
-  ysinus
- T
-
-c
-cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
-cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
-cc
-c   Autres  parametres ou cles  , non places dans run.def  mais
-c             dans les routines .
-cc
-ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
-cc
-cc  A )   iadv(iq )  , iq =1, nqmx , avec  iadv = 1  , shema humid.
-cc                                                  specifique LMD
-cc
-cc                                avec  iadv = 2  , shema amont
-cc
-cc                (  avec a l'interieur de amont , la cle amont_qs ) 
-cc
-cc                                avec  iadv = 3 , shema Van_Leer
-cc
-cc                                           dans  ***  gcm.F  ****
-cc 
-cc  B )  ok_oasis   , pour coupleur Oasis  , dans  *** physiq.F ***
-cc
-cc  C )  ok_ocean                            dans  *** physiq.F ***
-cc
-cc  D )  ok_journe , ok_instan, ok_region   pour sorties analyses
-c
-cc                                           dans  *** physiq.F ***
-cc
-cc  E ) nvm  : nbre  de vegetations    
-cc                                           dans  *** physiq.F ***
-
-cc  F ) deltay : deplacement ( en degres ) en  y  de la zone du zoom
-cc                                          dans  *** inigeom.F ***
-