Index: LMDZ.3.3/trunk/libf/dyn3d/read_fstoke.F
===================================================================
--- LMDZ.3.3/trunk/libf/dyn3d/read_fstoke.F	(revision 207)
+++ LMDZ.3.3/trunk/libf/dyn3d/read_fstoke.F	(revision 218)
@@ -28,5 +28,5 @@
      . rlatu_dy(imo1,jmo1),rlatv_dy(imo1,jmo)
       integer*4 ncrec,ncim,ncjm,nclm
-      real zrec,zim,zjm,zlm
+      integer*4 zrec,zim,zjm,zlm
       integer*4 xid,yid,zid,tid
       real*4 zdtvr,ziadvtrac
@@ -126,5 +126,9 @@
 c niveaux de pression
         
+#ifdef NC_DOUBLE
+       status=NF_GET_VARA_DOUBLE(ncidf,varidpl,1,zlm,pl)
+#else
        status=NF_GET_VARA_REAL(ncidf,varidpl,1,zlm,pl)
+#endif
 
 c rlonu,rlonv,rlatu,rlatv
@@ -140,6 +144,11 @@
       count(4)=0
 	
-	status=NF_GET_VARA_REAL(ncidf,varidnlo,start,count,rlonu_dy)
-        status=NF_GET_VARA_REAL(ncidf,varidnla,start,count,rlatu_dy)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidnlo,start,count,rlonu_dy)
+      status=NF_GET_VARA_DOUBLE(ncidf,varidnla,start,count,rlatu_dy)
+#else
+      status=NF_GET_VARA_REAL(ncidf,varidnlo,start,count,rlonu_dy)
+      status=NF_GET_VARA_REAL(ncidf,varidnla,start,count,rlatu_dy)
+#endif
 	
       start(1)=1
@@ -153,6 +162,11 @@
       count(4)=0
 
-        status=NF_GET_VARA_REAL(ncidfv,varidnlov,start,count,rlonv_dy)
-        status=NF_GET_VARA_REAL(ncidfv,varidnlav,start,count,rlatv_dy)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidfv,varidnlov,start,count,rlonv_dy)
+      status=NF_GET_VARA_DOUBLE(ncidfv,varidnlav,start,count,rlatv_dy)
+#else
+      status=NF_GET_VARA_REAL(ncidfv,varidnlov,start,count,rlonv_dy)
+      status=NF_GET_VARA_REAL(ncidfv,varidnlav,start,count,rlatv_dy)
+#endif
 
 c Lecture de phis et aire
@@ -169,21 +183,20 @@
 
 c phis
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidps,start,count,phis)
+#else
       status=NF_GET_VARA_REAL(ncidf,varidps,start,count,phis)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jmo1*1,phis)
-       call dump2d(imo1,jmo1,phis,'PHISNC')
+#endif
 
 c aire
+#ifdef NC_DOUBLE
+       status=NF_GET_VARA_DOUBLE(ncidf,varidai,start,count,airedy)
+#else
        status=NF_GET_VARA_REAL(ncidf,varidai,start,count,airedy)
-c      call correctbid(iim,jmo1*1,airedy)
-c       call dump2d(imo1,jmo1,airedy,'AIRENC')
-
-c        status= NF_CLOSE(ncidf)
+#endif
 
        else 
 
       print*,'ok1'
-c       stop'TEST lectfluxnc'
 
 c ---------------------
@@ -205,5 +218,9 @@
 
 c masse 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidm,start,count,masse)
+#else
       status=NF_GET_VARA_REAL(ncidf,varidm,start,count,masse)
+#endif
 c      print*,'WARNING!!! Correction bidon pour palier a un '
 c      print*,'probleme dans la creation des fichiers nc'
@@ -212,5 +229,9 @@
        call dump2d(imo1,jmo1,masse,'MASSE COUCHE 1')
 c pbaru 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidpu,start,count,pbaru)
+#else
       status=NF_GET_VARA_REAL(ncidf,varidpu,start,count,pbaru)
+#endif
 c      print*,'WARNING!!! Correction bidon pour palier a un '
 c      print*,'probleme dans la creation des fichiers nc'
@@ -219,5 +240,9 @@
 
 c w 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidw,start,count,w)
+#else
       status=NF_GET_VARA_REAL(ncidf,varidw,start,count,w)
+#endif
 c      print*,'WARNING!!! Correction bidon pour palier a un '
 c      print*,'probleme dans la creation des fichiers nc'
@@ -226,5 +251,9 @@
 
 c teta 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidt,start,count,teta)
+#else
       status=NF_GET_VARA_REAL(ncidf,varidt,start,count,teta)
+#endif
 c      print*,'WARNING!!! Correction bidon pour palier a un '
 c      print*,'probleme dans la creation des fichiers nc'
@@ -233,5 +262,9 @@
 
 c phi 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidph,start,count,phi)
+#else
       status=NF_GET_VARA_REAL(ncidf,varidph,start,count,phi)
+#endif
 c      print*,'WARNING!!! Correction bidon pour palier a un '
 c      print*,'probleme dans la creation des fichiers nc'
@@ -243,5 +276,9 @@
 c  pbarv
 	print*,'Lecture de pbarv irec=',irec
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidfv,varidpv,start,count,pbarv)
+#else
       status=NF_GET_VARA_REAL(ncidfv,varidpv,start,count,pbarv)
+#endif
 c      call correctbid(iim,jjm*nlevnc,pbarv)
 	PRINT*,'*******LECTURE DE PBARV******'